
// User code (C) 2008, 2010 Christian Gottschall

// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
    wahrheitstabelleEntfernen();
    CGWTAB.absteigend = widget.preferenceForKey( "absteigend" );
    if ( CGWTAB.absteigend != null )
    {
        var abstObj = document.getElementById( "istAbsteigendInput" );
        abstObj.checked = CGWTAB.absteigend;
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function getLocalizedString(key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch(ex)
	{
	}
    return key;
}


/*******************************************************************/

/*
	© Christian Gottschall
	
	November 2008, Mai 2010
	
	Alle Rechte - einschließlich derer der Vervielfältigung,
	Übersetzung und Verfilmung - vorbehalten.
*/


var CGWTAB = {
		verum:getLocalizedString("wahr"),
		falsum:getLocalizedString("falsch"),
		val_stapel:[],
		op_stapel:[],
        infixzeichen:"∧⋀&^∨⋁|v¬-~⊃⟶→⟷↔≡=>()!¡≠≢%⊼⊻⩑⩒⩟⩡↓↑",
        absteigend:true
	};
    
    
function wahrheitstabelleEntfernen()
{
	var scrollArea = document.getElementById("scrollArea"),
		obj = document.getElementById( "Wahrheitstabelle" ),
		attr;
	if ( obj )
		scrollArea.object.content.removeChild( obj );

	obj = document.createElement( "p" );
	obj.appendChild( document.createTextNode( "© 2008, 2010, 2012 Christian Gottschall" ) );

	attr = document.createAttribute( "id" );
	attr.nodeValue = "Wahrheitstabelle";
	obj.setAttributeNode( attr );
	attr = document.createAttribute( "align" );
	attr.nodeValue = "center";
	obj.setAttributeNode( attr );
	
	scrollArea.object.content.appendChild( obj );
	scrollArea.object.refresh();
}


function uebernehmen(event)
{
	var aussageObj = document.getElementById("aussage"),
		aussage = aussageObj.value,
		scrollArea = document.getElementById("scrollArea"),
		infix = 0, praefix = 0, i, c, table;
        
    if( aussage == null || aussage.length == 0 ) {
        wahrheitstabelleEntfernen();
        return;
    }
		
	try
	{
		for ( i = 0; i < aussage.length; i++ )
		{
			c = aussage.charAt( i );
			if ( "NKACE".indexOf(c) > 0 )
				praefix++;
            else if ( CGWTAB.infixzeichen.indexOf(c) > 0 )
                infix++;
		}
		
		table = document.getElementById( "Wahrheitstabelle" );
		if ( table )
			scrollArea.object.content.removeChild( table );


        var abstObj = document.getElementById( "istAbsteigendInput" );
        CGWTAB.absteigend = absteigend = abstObj.checked;
			
		table = wahrheitstabelleHtml( aussage, infix >= praefix, absteigend );

		if ( infix >= praefix )
		{
			aussage = verschoenern( aussage );
			aussageObj.value = aussage;
		}
				
		scrollArea.object.content.appendChild( table );
		scrollArea.object.refresh();
	}
	catch( e )
	{
		var obj = document.getElementById( "Wahrheitstabelle" );
		if ( obj )
			scrollArea.object.content.removeChild( obj );

		obj = document.createElement( "p" );
		obj.appendChild( document.createTextNode( e ) );

		attr = document.createAttribute( "id" );
		attr.nodeValue = "Wahrheitstabelle";
		obj.setAttributeNode( attr );
		
		scrollArea.object.content.appendChild( obj );
		scrollArea.object.refresh();
	}
}


function istKleinbuchstabe( c )
{
	return c === c.toLowerCase() && c !== c.toUpperCase();
}


function istGrossbuchstabe( c )
{
	return c === c.toUpperCase() && c !== c.toLowerCase();
}


function istBuchstabe( c )
{
	return istKleinbuchstabe(c) || istGrossbuchstabe(c);
}


function konstantenErmitteln( aussage, infix )
{
	var i, c, konstanten = "", sortarr, z;
	for ( i = 0; i < aussage.length; i++ )
	{
		c = aussage.charAt(i);
		if ( (infix ? istBuchstabe : istKleinbuchstabe)( c ) && c !== "v" &&
			 konstanten.indexOf( c.toLowerCase() ) < 0 )
			konstanten = konstanten + c.toLowerCase();
	}
	z = konstanten.length;
	sortarr = konstanten.split( "" );
	sortarr.sort();
	for ( i = 0, konstanten = ""; i < z; i++ )
		konstanten = konstanten + sortarr[i];
	return konstanten;
}


function wahrheitstabelleHtml( aussage, infix, absteigend )
{
	var	konstanten = konstantenErmitteln( aussage, infix ),
		zeilen = 1 << konstanten.length,
		bewertung, wert, table, thead, tbody,
		tr = document.createElement( "tr" ), attr, th;
				
	if ( zeilen > 1024 )
		throw getLocalizedString("Zu lang");
		
	table = document.createElement( "table" );
	attr = document.createAttribute( "id" );
	attr.nodeValue = "Wahrheitstabelle";
	table.setAttributeNode( attr );
	attr = document.createAttribute( "align" );
	attr.nodeValue = "center";
	table.setAttributeNode( attr );
				
	for ( i = 0; i < konstanten.length; i++ )
	{
		th = document.createElement( "th" );
		attr = document.createAttribute( "align" );
		attr.nodeValue = "center";
		th.setAttributeNode( attr );
		if ( infix )
			th.appendChild( document.createTextNode( konstanten.charAt(i).toUpperCase() ) );
		else
			th.appendChild( document.createTextNode( konstanten.charAt(i) ) );
		tr.appendChild( th );
	}
	th = document.createElement( "th" );
	attr = document.createAttribute( "align" );
	attr.nodeValue = "center";
	th.setAttributeNode( attr );
	if ( infix )
		th.appendChild( document.createTextNode( verschoenern( aussage ) ) );
	else
		th.appendChild( document.createTextNode( aussage ) );
	tr.appendChild( th );

	thead = document.createElement( "thead" );
	thead.appendChild( tr );
	table.appendChild( thead );
	
	tbody = document.createElement( "tbody" );
    
    for( bewertung = absteigend ? zeilen-1 : 0;
         absteigend && bewertung >= 0 ||
         ! absteigend && bewertung < zeilen;
         absteigend ? bewertung-- : bewertung++ )
	{
		tr = document.createElement( "tr" );
		for ( i = 0; i < konstanten.length; i++ )
		{
			wert = belegung( konstanten.charAt(i), bewertung, konstanten );
			td = document.createElement( "td" );
			attr = document.createAttribute( "align" );
			attr.nodeValue = "center";
			td.setAttributeNode( attr );
			td.appendChild(
				document.createTextNode( wert ? CGWTAB.verum : CGWTAB.falsum )
			);
			tr.appendChild( td );
		}
		wert = (infix ? infixbewerten : praefixbewerten)( aussage, bewertung, konstanten );
		td = document.createElement( "td" );
		attr = document.createAttribute( "align" );
		attr.nodeValue = "center";
		td.setAttributeNode( attr );
		td.appendChild( document.createTextNode( wert ? CGWTAB.verum : CGWTAB.falsum ) );
		tr.appendChild( td );
		tbody.appendChild( tr );
	}
	table.appendChild( tbody );

	return table;
}


function push_val( wert )
{
	CGWTAB.val_stapel[CGWTAB.val_stapel.length] = wert ? "1" : "0";
}


function pop_val()
{
	if ( ! CGWTAB.val_stapel || CGWTAB.val_stapel.length < 1 )
		throw getLocalizedString("Stapelunterlauf");
	var wert = CGWTAB.val_stapel[ CGWTAB.val_stapel.length - 1 ];
	CGWTAB.val_stapel.length = CGWTAB.val_stapel.length - 1;
	return wert === "1" ? true : false;
}


function peek_val()
{
	if ( ! CGWTAB.val_stapel || CGWTAB.val_stapel.length < 1 )
		throw getLocalizedString("Stapelunterlauf");
	var wert = CGWTAB.val_stapel[ CGWTAB.val_stapel.length - 1 ];
	return wert === "1" ? true : false;
}


function push_op( wert )
{
	CGWTAB.op_stapel[CGWTAB.op_stapel.length] = wert;
}


function pop_op()
{
	if ( ! CGWTAB.op_stapel || CGWTAB.op_stapel.length < 1 )
		throw getLocalizedString("Stapelunterlauf");
	var wert = CGWTAB.op_stapel[ CGWTAB.op_stapel.length - 1 ];
	CGWTAB.op_stapel.length = CGWTAB.op_stapel.length - 1;
	return wert;
}


function peek_op()
{
	if ( ! CGWTAB.op_stapel || CGWTAB.op_stapel.length < 1 )
		throw getLocalizedString("Stapelunterlauf");
	return CGWTAB.op_stapel[ CGWTAB.op_stapel.length - 1 ];
}


function op_avail()
{
	return CGWTAB.op_stapel.length > 0;
}


function belegung( c, bewertung, konstanten )
{
	var i, m;
	
	if ( c === "v" ) throw getLocalizedString("v ist Disjunktion");
	i = konstanten.indexOf( c );
	if ( i < 0 ) throw getLocalizedString("Abwesende Konstante") + " \"" + c + "\".";
	m = 1 << (konstanten.length - i - 1);
	return (bewertung & m) ? true : false;
}


function praefixbewerten( aussage, bewertung, konstanten )
{
	var i, c, p, q, resultat;
	CGWTAB.val_stapel.length = 0;
	try
	{
		for ( i = aussage.length-1; i >= 0; i-- )
		{
			c = aussage.charAt(i);
			switch( c )
			{
				case "1":	push_val( true ); break;
				case "0":	push_val( false ); break;
				case 'N':	push_val( ! pop_val() ); break;
				case "C":	p = pop_val(); q = pop_val();
							push_val( ! p || q ); break;
				case 'E':	p = pop_val(); q = pop_val(); push_val( p === q ); break;
				case 'K':	p = pop_val(); q = pop_val(); push_val( p && q ); break;
				case 'A':	p = pop_val(); q = pop_val(); push_val( p || q ); break;
				default:	if ( ! istKleinbuchstabe(c) )
								throw getLocalizedString("Unerlaubtes Zeichen") +
									  " \"" + c + "\".";
							push_val( belegung( c, bewertung, konstanten ) ); break;
			}
		}
		resultat = pop_val();
		if ( CGWTAB.val_stapel.length !== 0 )
			throw getLocalizedString("Stapel wird nicht leer");
		return resultat;
	}
	catch( e )
	{
		throw e;
	}
	finally
	{
		CGWTAB.val_stapel = [];
	}
}


function pruefePraefixAussage(aussage)
{
	var i, c, sp;
	if ( aussage.length === 0 ) return false;
	for ( i = aussage.length-1, sp = 0; i >= 0; i-- )
	{
		c = aussage.charAt(i);
		switch( c )
		{
			case '1': case "0":	sp++; break;
			case 'N':			if ( sp < 1 )
									return false;
								break;
			case "C": case 'E':
			case 'K': case 'A':	if ( sp < 2 )
									return false;
								sp--; break;
			default:			if ( ! istKleinbuchstabe(c) )
									return false;
								sp++; break;
		}
	}
	return sp === 1;
}


function op_prio(op)
{
    switch(op)
    {
        case "¬": case "-": case "~":            return 1;
        case "!": case "&": case "^":
        case "⊼": case "⩑": case "⩟":
        case "∧": case "⋀": case "↑":            return 2;
        case "∨": case "⋁": case "v": case "%":
        case "⊻": case "⩒": case "⩡": case "↓":
        case "|": case "v": case "¡":            return 3;
        case ">": case "->": case "=>":
        case "-->" : case "==>":
        case "⊃": case "⟶": case "→":           return 4;
        case "=": case "⟷": case "↔":
        case "≡":                                return 5;
        case ")":                                return 6;
        default: throw getMessage("Unbekannter Operator") + " \"" + op + "\".";
    }
    return-1;
}


function do_op()
{
    var op = pop_op(), p, q;
    switch(op)
    {
        case "¬": case "-": case "~":
            p = pop_val(); push_val( ! p ); break;
        case "!": case "⊻": case "⩒": case "⩡": case "↓":
            p = pop_val(); q = pop_val(); push_val( !(p || q) ); break;
        case "¡": case "⊼": case "⩑": case "⩟": case "↑":
            p = pop_val(); q = pop_val(); push_val( !(p && q) ); break;
        case "%":
            p = pop_val(); q = pop_val(); push_val( p && !q || !p && q ); break;
        case "=": case "⟷": case "↔": case "≡":
            p = pop_val(); q = pop_val(); push_val( p && q || !p && !q ); break;
        case "!": case "&": case "^": case "∧": case "⋀":
            p = pop_val(); q = pop_val(); push_val( p && q ); break;
        case "∨": case "⋁": case "v": case "|": case "v":
            p = pop_val(); q = pop_val(); push_val( p || q ); break;
        case ">": case "->": case "=>": case "-->" : case "==>":
        case "⊃": case "⟶": case "→":
            p = pop_val(); q = pop_val(); push_val( ! p || q ); break;
        case ")":
            throw getMessage("Zu viele geschlossene Klammern");
        default:
            throw getMessage("OP-Fehler") + "\"" + CGWTAB.op_stapel + "\"" +
                  ", op=\"" + op + "\".";
    }
}


function infixbewerten( aussage, bewertung, konstanten )
{
    var i, c, p, q, resultat;
    CGWTAB.val_stapel.length = 0;
    CGWTAB.op_stapel.length = 0;
    try
    {
        for ( i = aussage.length-1; i >= 0; i-- )
        {
            c = aussage.charAt(i);
            switch( c )
            {
                case "0":
                    push_val( false ); break;
                case "1":
                    push_val( true ); break;
                case " ":
                    break;
                case "¬": case "-": case "~":
                case "!": case "↓": case "⊻": case "⩒": case "⩡":
                case "¡": case "⊼": case "⩑": case "⩟":
                case "%": case "=": case "⟷": case "↔": case "≡":
                case "!": case "&": case "^": case "∧": case "⋀":
                case "∨": case "⋁": case "v": case "|": case "v":
                case ">": case "->": case "=>": case "-->" : case "==>":
                case "⊃": case "⟶": case "→":
                case "↑": case "↓":
                    if ( c === ">" && i > 0 )
                    {
                        var d = aussage.charAt( i - 1 );
                        if ( (d === '-' || d === '=') && --i > 0 )
                        {
                            var e = aussage.charAt( i - 1 );
                            if ( e === d )
                            {
                                if ( --i > 0 && ((d = aussage.charAt(i-1)) === '-' ||
                                                 d === '=') )
                                    throw getMessage("Konditionalfehler") +
                                          (i+1);
                            }
                            else if ( e === "-" || e === "=" )
                                throw getMessage("Konditionalfehler") +
                                      (i+1);
                        }
                    }
                    if ( op_avail() && op_prio( peek_op() ) < op_prio( c ) )
                        do_op();
                    push_op( c );
                    break;
                case ")":
                    push_op( c );
                    break;
                case "(":
                    while( peek_op() !== ")" )
                        do_op();
                    if ( pop_op() !== ")" )
                        throw getMessage("Klammer zu erwartet");
                    break;
                default:
                    if ( ! istBuchstabe(c) )
                        throw getMessage("Unerlaubtes Zeichen") + " \"" + c + "\".";
                    push_val( belegung( c.toLowerCase(), bewertung, konstanten ) );
                    break;
            }
        }
        while( op_avail() )
            do_op();
        resultat = pop_val();
        if ( CGWTAB.val_stapel.length !== 0 || CGWTAB.op_stapel.length !== 0 )
            throw getMessage("Stapel wird nicht leer");
        return resultat;
    }
    catch( e )
    {
        throw e;
    }
    finally
    {
        CGWTAB.val_stapel = [];
        CGWTAB.op_stapel = [];
    }
}


function verschoenern( aussage )
{
	var schoen = aussage.toUpperCase().replace( /V/g, "v" );
	schoen = schoen.replace( /--?>/g, "→" );
	schoen = schoen.replace( /==?>/g, "→" );
	schoen = schoen.replace( />/g, "→" );
	schoen = schoen.replace( /[v|]/g, "∨" );
	schoen = schoen.replace( /[&^]/g, "∧" );
	schoen = schoen.replace( /=/g, "↔" );
	schoen = schoen.replace( /!/g, "↓" );
	schoen = schoen.replace( /¡/g, "↑" );
	schoen = schoen.replace( /[~-]/g, "¬" );
	return schoen;
}


function internetaufruf(event)
{
	var url = getLocalizedString( "URL" );
	widget.openURL( url );
}


function reihenfolgeGeaendert(event)
{
    wahrheitstabelleEntfernen();
    uebernehmen();
    widget.setPreferenceForKey( CGWTAB.absteigend, "absteigend" );
}


